#-*- coding: utf-8 -*-
# Tistory to TTXML
# Japanese characters cannot be processed.
# Protected (or secret) posts cannot be processed.
# post ID should be number such like: http://snowall.tistory.com/5
# No responsible for snowall on whatever you would be faced.
# Copyright: Keehwan, Nam. snowall@gmail.com 2017. 2. 9.
# This source code is licensed under any version of GNU Public License.
#
# v0.1

from bs4 import BeautifulSoup as soup
import time
import os.path as ospath
import http.client
from urllib.parse import urlparse
from xml.sax.saxutils import escape
def wget(url):
	dom=urlparse(url)[1]
	fil=urlparse(url)[2]
	conn=http.client.HTTPConnection(dom)
	conn.request("GET",fil)
	da=conn.getresponse()
	if da.status==200:
		htmlfile=open(str(fil[1:].replace("/","\\")),"wb")
		htmlfile.write(da.read())
		htmlfile.close()
	conn.close()

xmlfile=open("test.xml","w")
xmlfile.write("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>")
xmlfile.write("<blog type=\"tattertools/1.1\" migrational=\"true\">")
domainname="\"melotopia.net/b\""
logfile=open("log.txt","w")
idname=1
while idname<4: # Larger than your post number.
	conn=http.client.HTTPConnection("beebop.tistory.com")
	conn.request("GET","/"+str(idname))
	da=conn.getresponse()
	if da.status==200:
		htmlfile=open(str(idname)+".html","wb")
		htmlfile.write(da.read())
		htmlfile.close()
	conn.close()
	try:
		if ospath.exists(str(idname)+".html"):
			print(idname)
			so=open(str(idname)+".html","rb").read()

			so=soup(so,"html.parser")
			so=so.prettify().replace(u'\xa0', u' ')
			so=soup(so,"html.parser")
			xmlfile.write("<post slogan=\"\" format=\"1.1\">")
			xmlfile.write("<author domain="+domainname+">"+so('div',{'class':'author'})[0]('span',{'class':'txt'})[0].string.replace(" ","").replace("\n","")+"</author>")
			xmlfile.write("<id>"+str(idname)+"</id>")
			try:
				try:
					xmlfile.write("<title>"+so('a',{'class':'link'})[0].string+"</title>")
				except:
					xmlfile.write("<title>"+so('a',{'class':'link'})[0].string.encode("utf-8")+"</title>")
			except:
				xmlfile.write("<title>"+"이 글의 제목을 알려주세요"+"</title>")
				logfile.write(str(idname)+",post title error\n")
			xmlfile.write("<visibility>public</visibility>")
			xmlfile.write("<content>")
			mycontent=str(so('div',{'class':'desc'})[0])


			for urls in so('div',{'class':'desc'})[0]('img'):
				try:
					if urls.has_attr('alt') and urls['alt']=="신고":
						pass
					else:
						mycontent=mycontent.replace(urlparse(urls['src'])[0]+"://"+urlparse(urls['src'])[1]+"/","")
						try:
							wget(urls['src'])
						except:
							logfile.write(str(idname)+",thumbnail image download error\n")
							pass
						try:
							wget(urls['onclick'].split('\'')[1])
						except:
							logfile.write(str(idname)+",original image download error\n")
							pass
				except:
					logfile.write(str(idname)+",content url parsing error\n")
				mycontent=str(escape(mycontent))
			try:
				xmlfile.write(mycontent)
			except:
				logfile.write(str(idname)+",content error\n")
				pass
			xmlfile.write("</content>")
			xmlfile.write("<location></location>")
			xmlfile.write("<password></password>")
			xmlfile.write("<acceptTrackback>")
			xmlfile.write(so('span',{'id':'trackbackCount'+str(idname)})[0]('span',{'class':'txt_em'})[0].string)
			xmlfile.write("</acceptTrackback>")
			xmlfile.write("<acceptComment>")
			xmlfile.write(so('span',{'id':'commentCount'+str(idname)})[0]('span',{'class':'txt_em'})[0].string)
			xmlfile.write("</acceptComment>")
			timetext=so('div',{'class':'author'})[0]('span',{'class':'date'})[0].string.replace("  ", "").replace('\n','')

			if timetext[0]==" ":
				timetext=timetext[1:]
			if timetext[-1]==" ":
				timetext=timetext[:-1]

			xmlfile.write("<published>")
			xmlfile.write(str(int(time.mktime(time.strptime(timetext,"%Y.%m.%d %H:%M")))))
			xmlfile.write("</published>")
			xmlfile.write("<created>")
			xmlfile.write(str(int(time.mktime(time.strptime(timetext,"%Y.%m.%d %H:%M")))))
			xmlfile.write("</created>")
			xmlfile.write("<modified>")
			xmlfile.write(str(int(time.mktime(time.strptime(timetext,"%Y.%m.%d %H:%M")))))
			xmlfile.write("</modified>")
			for cat in so('a',{'class':'category'})[0].string.split("/"):
				xmlfile.write("<category>")
				xmlfile.write(cat)
				xmlfile.write("</category>")
			com=so('div',{'class':'wrap_guestlist entry_comment'})[0]
			if com('ul',{'class':'list_guest'})==[]:
				pass
			else:
				com=com('ul',{'class':'list_guest'})[0]
				for cc in com('li'):
					try:
						xmlfile.write("<comment>")
						xmlfile.write("<commenter id=\""+cc['id']+"\">")
						xmlfile.write("<name>")
						try:
							try:
								xmlfile.write(cc('span',{'class':'name'})[0].string)
							except:
								xmlfile.write(cc('span',{'class':'name'})[0]('a')[0].string)
						except:
							logfile.write(str(idname)+",comment name error\n")
							xmlfile.write("noname")

						xmlfile.write("</name>")
						xmlfile.write("<homepage>")
						try:
							href=cc('span',{'class':'name'})[0]('a')[0]['href'].replace("snowall.tistory.com","melotopia.net/b")
							xmlfile.write(href)
						except:
							logfile.write(str(idname)+",comment homepage error\n")
							pass
						xmlfile.write("</homepage>")
						xmlfile.write("</commenter>")
						xmlfile.write("<content>")
						try:
							xmlfile.write(escape(str(cc('p',{'class':'comment'})[0])))
						except:
							logfile.write(str(idname)+",comment content error\n")
							pass
						xmlfile.write("</content>")
						xmlfile.write("<password></password>")
						xmlfile.write("<written>")

						timetext=cc('span',{'class':"date"})[0].prettify().split("\n")[1]
						if timetext[0]==" ":
							timetext=timetext[1:]
						if timetext[-1]==" ":
							timetext=timetext[:-1]

						xmlfile.write(str(int(time.mktime(time.strptime(timetext,"%Y.%m.%d %H:%M")))))
						xmlfile.write("</written>")
						xmlfile.write("<isFiltered>0</isFiltered>")
						xmlfile.write("</comment>")
					except:
						logfile.write(str(idname)+",no comment\n")
						pass
			xmlfile.write("</post>")
		else:
			logfile.write(str(idname)+",no file\n")
			pass
	except:
		pass
	idname+=1
xmlfile.write("</blog>")
xmlfile.close()
